#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <windows.h>

#ifndef __MAPPINGLIB_H
#define __MAPPINGLIB_H

/* acquire a control box: use index to choose which box (1-3)*/
__declspec(dllexport) void* acquireCtrlBox( int index );

/* release the control box */
__declspec(dllexport) void releaseCtrlBox( void* pm );

/* set the valid range for all the fingers and all the joints
   inrs[5][2]: min and max of fingers, in order from pinky to thumb 
   outrs[5][2]: min and max of joints, in order from base to grip
*/
__declspec(dllexport) BOOL setCtrlBox( void* pm, double inrs[5][2], double outrs[5][2] );

/* initialize control box, giving the initial state of the system
   ins[5]: start position of the fingers, pinky to thumb
   outs[5]: start position of the joints, base to grip
   all the values should be within the ranged defined in setCtrlBox method
   the inside clock of the box will be set as 0
*/
__declspec(dllexport) void kickoffCtrlBox( void* pm, double ins[5], double outs[5] );

/* trigger control box, giving the next time inputs and current time outputs
   input -	ins[5]: the glove reading at time (t+1)
			outs[5]: the joint angles at time t
			time: t+1 in seconds
   output - outs[5]: the target joint angles at time t+1
*/
__declspec(dllexport) void passCtrlBox( void* pm, double ins[5], double outs[5], double time );


#endif